# coding=utf8

import sys
import os
import time
import cgi
import cgitb
import html
from kml import *
from kml import deb
from subprocess import Popen

class Http():
    titles = {}
    titles['general'] = """
● vytvoří KML-stream z elementů LookAt pro GoogleEarth tak, aby vznikl pohyb kamery jako symetrický průlet kolem cílového bodu, na který kamera po celou dobu letu hledí
● cílový bod leží v počátku lokálních souřadnic letu
● křivka průletu je parabola y = abs(Y1 + x**exp) s počátkem v bodu průletu a je symetrická podle roviny y,z lokálních souřadnic
● zadávané souřadnice výchozího bodu a bodu průletu jsou lokální souřadnice (v metrech) vzhledem k cílovému bodu
● výchozí bod má souřadnice X0>=0, Y0, Z0>{minZ}; pro X0=0 se vytváří jen jediný LookAt (vlastně Placemark)
● bod průletu má souřadnice X1=0, Y1, Z1>{minZ}
● zadávaný exponent paraboly je exp>0; pro exp=1 přejde parabola do polopřímek
● pro Z0=Z1 probíhá let ve vodorovné rovině, pro Y0=Y1 ve svislé rovině rovnoběžné s osou x
● zadávané geodetické souřadnice cílového bodu (ve stupních) a azimut kamery na startu (sever=0) uchycují lokální soustavu do geodetických souřadnic, výška cílového bodu je vždy 0 nad terénem
● průběh rychlosti se může zadat jako nelineární se zpomalením v průletu s několika druhy průběhu
● přepínač "flyby" řídí vytvoření celého průletu nebo jen letu do největšího přiblížení (do bodu průletu)
● konfigurace letů a geo-souřadnice cílových bodů je možno pojmenovat a uložit ("store conf" resp. "store geo") a později vytáhnout do formuláře ("get conf" resp. "get geo")
"""
    titles['name'] = 'jméno pro uložení aktuální konfigurace z obrazovky na server {server}'
    titles['target'] = 'jméno pro uložení aktuálních geodetických souřadnic cílového bodu z obrazovky na server {server}'
    titles['submitstored'] = 'vytvořit KML-stream z konfigurace uložené na serveru {server} pod zadaným jménem'
    titles['submitconf'] = 'vytvořit KML-stream z konfigurace vyplněné ve formuláři na obrazovce'
    titles['storeconf'] = 'uložit konfiguraci na server {server} pod jménem zadaným v položce name'
    titles['getconf'] = 'vytáhnout konfiguraci uloženou na serveru {server} pod zadaným jménem'
    titles['storegeo'] = 'uložit souřadnice cílového bodu na server {server} pod jménem zadaným v položce target'
    titles['getgeo'] = 'vytáhnout souřadnice cílového bodu uložené na serveru {server} pod jménem zadaným v položce target'
    titles['azimuth'] = 'geodetický azimut cílového bodu při pohledu z výchozího bodu x0,y0,z0'
    titles['speedfact'] = 'koeficient konstantní složky rychlosti letu >0'
    titles['slowfact'] = 'koeficient zpomalení v průletu >0'
    titles['slowdown'] = 'průběh zpomalení v průletu'
    titles['exponent'] = 'exponent (>0) průletové paraboly x = abs(Y1 + x**exp); pro exp=1 přejde parabola do polopřímek s počátkem v bodu průletu'
    titles['flyby'] = 'přepínač průlet/nálet; nálet = let z výchozího bodu do maximálního přiblížení (bodu průletu)'
    titles['steps'] = 'počet bodů KML-streamu < {stepsMax}'
    titles['xyz0'] = 'lokální souřadnice X0>=0, Y0, Z0>{minZ} v metrech výchozího (krajního) bodu průletové paraboly x = abs(Y1 + x**exp); počátek lokálních souřadnic je v cílovém bodě'
    titles['xyz1'] = 'lokální souřadnice X1=0, Y1, Z1>{minZ} bodu průletu kolem cílového bodu po parabole x = abs(Y1 + x**exp); počátek lokálních souřadnic je v cílovém bodě'
    titles['lat'] = 'geodetická šířka cílového bodu ve stupních -90<š<90; cílový bod je zároveň počátkem lokálních souřadnic letové paraboly'
    titles['long'] = 'geodetická délka cílového bodu ve stupních -180<d<180; cílový bod je zároveň počátkem lokálních souřadnic letové paraboly'

    def __init__(self, config):
        self.c = config
        self.titles['general'] = self.titles['general'].format(minZ=self.c.minZ)
        self.titles['xyz0'] = self.titles['xyz0'].format(minZ=self.c.minZ)
        self.titles['xyz1'] = self.titles['xyz1'].format(minZ=self.c.minZ)
        self.titles['steps'] = self.titles['steps'].format(stepsMax=self.c.stepsMax)
        self.titles['name'] = self.titles['name'].format(server=self.c.configqual)
        self.titles['target'] = self.titles['target'].format(server=self.c.configqual)
        self.titles['submitstored'] = self.titles['submitstored'].format(server=self.c.configqual)
        self.titles['storeconf'] = self.titles['storeconf'].format(server=self.c.configqual)
        self.titles['getconf'] = self.titles['getconf'].format(server=self.c.configqual)
        self.titles['storegeo'] = self.titles['storegeo'].format(server=self.c.configqual)
        self.titles['getgeo'] = self.titles['getgeo'].format(server=self.c.configqual)
        # deb(self.titles)

    def parsehttp(self, msg):
        c = self.c
        # cgitb.enable()
        p = cgi.parse()
        # deb(('parsehttp, p', p))

        c.domainname = '.'.join(os.environ['HTTP_HOST'].split('.')[1:])
        if c.name.keyact in p: c.name.val = p[c.name.keyact][0]
        if c.name.key in p: c.name.val = p[c.name.key][0]
        if c.targname.keyact in p: c.targname.val = p[c.targname.keyact][0]
        if c.slowdown.keyact in p: c.slowdown.val = p[c.slowdown.keyact][0]

        if 'downlkml' in p:
            self.sendfile(c.kmlfile)
            return False
        if 'downlurl' in p:
            self.httpheader(c.urlfile)
            Kml().urlPlacemark(c.dnldUrl, c.dnldPath)
            sys.stdout.close()
            # self.sendfile(c.urlfile)
            return False

        c.restoreparms()

        if 'getparms' in p:
            return False
        if 'submitstored' in p:
            if c.flagged:
                return False
            else:
                c.adjust()
                return True

        c.update_influentials(p)

        if 'gettarget' in p:
            c.long.val, c.lat.val = c.gettarget(c.targname.val)
            return False
        if 'storetarget' in p and c.lat.chk and c.long.chk:
            c.storetarget(c.targname.val, c.long.val, c.lat.val)
            return False

        if c.flagged:
            return False
        c.adjust()
        if 'submit' in p:
            return True
        if 'storeparms' in p:
            c.storeparms()
            return False
        return False

    def htmlhead(self):
        print("Content-type: text/html")
        print('')
        print('<!DOCTYPE html><html><head>')
        print('<meta charset=\"utf-8\"/>')
        print('<style type="text/css">')
        print('.box {border: 1px solid; padding: .4em}')
        print('.round {border:.12em solid; border-radius:50%; width:1.2em; line-height:1.2em; text-align:center;}')
        print('.flag {background-color: #ffaaaa}')
        print('.emph {color: #ff00ff; font-weight: bold}')
        print('</style>')
        print('</head><body>')
        print('<div style="display:flex" title="{}">'.format(html.escape(self.titles['general'])))
        print('<br><span class="box"><b>Google Earth parabolic flyby</b></span>')
        print('&nbsp;<div><div class="round"><b>?</b></div></div>')
        print('</div><br>')

    def htmltrail(self):
        print('</body></html>')

    def sendform(self, confirm=True):
        c = self.c
        # cgitb.enable()
        # cgi.test()
        self.htmlhead()
        if(confirm): self.sendconfirm()

        if(c.flagged):
            print('<p style="color: red"><b>FLAG</b></p>')
        print('<form method=POST>')
        print('<input type=hidden name="{kaname}" value="{actualname}">'
              .format(kaname=c.name.keyact, actualname=c.name.val))
        print('<input type=hidden name="{katargname}" value="{actualtargname}">'
              .format(katargname=c.targname.keyact, actualtargname=c.targname.val))
        print('<input type=hidden name="{kaslowdown}" value="{actualsldn}">'
              .format(kaslowdown=c.slowdown.keyact, actualsldn=c.slowdown.val))

        print('<table><tr><td><label><b>name</b> [{name}]<br><input type="text" name="{kname}" list="names" title="{tname}">'
              .format(kname=c.name.key, name=c.name.val, tname=self.titles['name']))
        print('<datalist id="names">')
        for i in c.parmsls():
            print('<option value="{}"/>'.format(i))
        print('</datalist></input></label></td></tr></table>')
        print('<input type=submit name="getparms" value="get stored conf" title="{}">'
              .format(self.titles['getconf']))
        print('<input type=submit name="storeparms" value="store conf" title="{}">'
              .format(self.titles['storeconf']))
        print('<input type=submit name="submitstored" value="submit stored conf" title="{}">'
              .format(html.escape(self.titles['submitstored'])))
        print('<br><br>')

        print('<table><tr><td><label><b>target</b> [{targname}]<br><input type="text" name="{ktargname}" list="targets" title="{ttarget}">'
              .format(ktargname=c.targname.key, targname=c.targname.val, ttarget=self.titles['target']))
        print('<datalist id="targets">')
        for i in c.targsls():
            print('<option value="{}"/>'.format(i))
        print('</datalist></input></label></td>')
        print('<td><label><b>latitude<br><input type="text" name="{kla}" value="{vla}" title="{lat}" class="{flag}"></td>'
              .format(kla=c.lat.key, vla=c.lat.val, lat=self.titles['lat'], flag='' if c.lat.chk else 'flag'))
        print('<td><label><b>longitude<br><input type="text" name="{klo}" value="{vlo}" title="{long}" class="{flag}"></td>'
              .format(klo=c.long.key, vlo=c.long.val, long=self.titles['long'], flag='' if c.long.chk else 'flag'))
        print('</tr></table>')
        print('<input type=submit name="gettarget" value="get stored geo" title="{}">'
              .format(self.titles['getgeo']))
        print('<input type=submit name="storetarget" value="store geo" title="{}">'
              .format(self.titles['storegeo']))
        print('<br><br>')

        print('<table><tr>')
        print('<td><label><b>X0<br><input type="text" name="{kx0}" value="{vx0}" title="{xyz0}" class="{flag}"></label></td>'
              .format(kx0=c.x0.key, vx0=c.x0.val, xyz0=self.titles['xyz0'], flag='' if c.x0.chk else 'flag'))
        print('<td><label><b>Y0<br><input type="text" name="{ky0}" value="{vy0}" title="{xyz0}" class="{flag}"></label></td>'
              .format(ky0=c.y0.key, vy0=c.y0.val, xyz0=self.titles['xyz0'], flag='' if c.y0.chk else 'flag'))
        print('<td><label><b>Z0<br><input type="text" name="{kz0}" value="{vz0}" title="{xyz0}" class="{flag}"></label></td>'
              .format(kz0=c.z0.key, vz0=c.z0.val, xyz0=self.titles['xyz0'], flag='' if c.z0.chk else 'flag'))
        print('</tr>')
        print('<tr>')
        print('<td><label><b>azimuth<br><input type="text" name="{kh0}" value="{vh0}" title="{azimuth}" class="{flag}"></label></td>'
              .format(kh0=c.h0.key, vh0=c.h0.val, azimuth=self.titles['azimuth'], flag='' if c.h0.chk else 'flag'))
        print('<td><label><b>Y1<br><input type="text" name="{ky1}" value="{vy1}" title="{xyz1}" class="{flag}"></label></td>'
              .format(ky1=c.y1.key, vy1=c.y1.val, xyz1=self.titles['xyz1'], flag='' if c.y1.chk else 'flag'))
        print('<td><label><b>Z1<br><input type="text" name="{kz1}" value="{vz1}" title="{xyz1}" class="{flag}"></label></td>'
              .format(kz1=c.z1.key, vz1=c.z1.val, xyz1=self.titles['xyz1'], flag='' if c.z1.chk else 'flag'))
        print('<tr/>')
        print('<tr>')
        print('<td><label><b>speed factor<br><input type="text" name="{kspeedfact}" value="{speedfact}" title="{tspeedfact}" class="{flag}"></label></td>'
              .format(kspeedfact=c.speedfact.key, speedfact=c.speedfact.val, tspeedfact=self.titles['speedfact'], flag='' if c.speedfact.chk else 'flag'))
        print('<td><label><b>slowdown</b> [{slowdown}]<br><input type="text" name="{kslowdown}" list="slowdowns" title="{tslowdown}" class="{flag}"></label></td>'
              .format(kslowdown=c.slowdown.key, slowdown='' if not c.slowdown.chk else SpeedAdjust.abrv[c.slowdown.val],
                      tslowdown=self.titles['slowdown'], flag='' if c.slowdown.chk else 'flag'))
        print('<td><label><b>slowdown factor<br><input type="text" name="{kslowdfact}" value="{slowdfact}" title="{tslowfact}" class="{flag}"></label></td>'
              .format(kslowdfact=c.slowdfact.key, slowdfact=c.slowdfact.val, tslowfact=self.titles['slowfact'], flag='' if c.slowdfact.chk else 'flag'))
        print('</tr>')
        print('<tr>')
        print('<td><label><b>exponent<br><input type="text" name="{kex}" value="{vex}" title="{exponent}" class="{flag}"></label></td>'
              .format(kex=c.exp.key, vex=c.exp.val, exponent=self.titles['exponent'], flag='' if c.exp.chk else 'flag'))
        print('<td><label><b>flyby<br><input type="text" name="{kfl}" value="{vfl}" title="{flyby}"></label></td>'
              .format(kfl=c.flyby.key, vfl=(1 if c.flyby.val else 0), flyby=self.titles['flyby']))
        print('<td><label><b># of steps<br><input type="text" name="{kst}" value="{vst}" title="{steps}" class="{flag}"></label></td>'
              .format(kst=c.steps.key, vst=c.steps.val, steps=self.titles['steps'], flag='' if c.steps.chk else 'flag'))
        print('</tr>')
        print('</table>')

        print('<input type=submit name="submit" value="submit conf" title="{submitconf}">'
              .format(submitconf=self.titles['submitconf']))
        print('<input type=submit name="storeparms" value="store conf" title="{storeconf}">'
              .format(storeconf=self.titles['storeconf']))
        print('<datalist id="slowdowns">')
        for i in SpeedAdjust.keys:
            print('<option value="{}"/>'.format(i))
        print('</datalist></form>')
        self.htmltrail()

    def sendconfirm(self):
        print("""
        <b>{}</b><br><br>
        <div style="font-size: smaller;">
        Flyby KML is <span class="emph">ready</span> to be opened on Google Earth (GE):<br>
        <ul>
        <li>for both <b>standalone-</b> and <b>web-GE</b> download KML and open file on GE</li>
        or<br>
        <li>on standalone-GE open KML directly via html-ref placemark http://{}/<br>
        <span style="font-style: italic;">(download URL-placemark and place it (via open) in GE's placemarks for subsequent direct openings)</span>.</li>
        </ul></div>
        <form method=POST>
        <input type="submit" name="downlkml" value="download flyby KML">
        <input type="submit" name="downlurl" value="download URL placemark">
        </form>
        <div style="font-size: 66%;"><br>{conf}<br>{coor}<br></div>
        <hr><br>
        """.format(time.asctime(), self.c.dnldqual, conf=self.c.confcomm, coor=self.c.coorcomm))

    def httpheader(self, fn):
        print('Content-Type: application/vnd.google-earth.kml+xml')
        print('Content-Disposition: attachment; filename="{}"'.format(fn))
        print()

    def sendfile(self, fn):
        self.httpheader(fn)
        sys.stdout.flush()
        p = Popen(('cat', fn))
        p.wait()
        sys.stdout.close()
